/***************************************
* ZeusCMD - OpenGL Tutorial 11 : Depth *
* By Grant James (ZEUS)                *
* http://www.zeuscmd.com               *
***************************************/
#include <windows.h>
#include "glutil.h"

OpenGL *opengl;

void drawTriangle()
{
	glBegin(GL_TRIANGLES);
		glColor3f(1.0f, 0.0f, 0.0f);
		glVertex2f( 0.5f, -0.5f);
		glColor3f(0.0f, 1.0f, 0.0f);
		glVertex2f( 0.0f,  0.5f);
		glColor3f(0.0f, 0.0f, 1.0f);
		glVertex2f(-0.5f, -0.5f);
	glEnd();
}

bool init()
{
	glClearColor(0.93f, 0.93f, 0.93f, 0.0f);

	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glClearDepth(1.0f);

	return true;
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	drawTriangle();

	glPushMatrix();
	{
		glTranslatef(-0.2f, 0.0f, -1.0f);

		drawTriangle();

		glRotatef(45.0f, 0.0f, 0.0f, 1.0f);

		drawTriangle();
	}
	glPopMatrix();

	glPushMatrix();
	{
		glTranslatef(0.5f, 0.0f, 0.0f);
		glScalef(0.5f, 0.5f, 0.5f);

		drawTriangle();
	}
	glPopMatrix();
		
	glFlush();
}

void resize(int w, int h)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glViewport(0, 0, w, h);
	glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0f, 20.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void idle()
{
	if (opengl->isKeyDown('D'))
	{
		opengl->keyUp('D');

		if (glIsEnabled(GL_DEPTH_TEST))
			glDisable(GL_DEPTH_TEST);
		else
			glEnable(GL_DEPTH_TEST);
	}
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	opengl = OpenGL::create();

	opengl->setInitFunc(init);
	opengl->setDisplayFunc(display);
	opengl->setIdleFunc(idle);
	opengl->setResizeFunc(resize);

	if (!opengl->initGL("11 - Depth", 500, 500, false, 32))
		return 1;

	opengl->runMessageLoop();

	return 0;
}
